function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useEffect, useMemo, useState } from 'react';
import { getTargetElement } from '../utils';
import { useSize } from './use-size';
export function useGrid(options) {
  var _useState = useState(function () {
      return {
        rows: 0,
        cols: 0
      };
    }),
    _useState2 = _slicedToArray(_useState, 2),
    grid = _useState2[0],
    setGrid = _useState2[1];
  var target = options.target,
    itemMinWidth = options.itemMinWidth,
    itemMinHeight = options.itemMinHeight,
    _options$gutter = options.gutter,
    gutter = _options$gutter === void 0 ? 0 : _options$gutter;
  var _useMemo = useMemo(function () {
      if (typeof gutter === 'number') {
        return [gutter, gutter];
      }
      return gutter;
    }, [gutter]),
    _useMemo2 = _slicedToArray(_useMemo, 2),
    gutterX = _useMemo2[0],
    gutterY = _useMemo2[1];
  var size = useSize(target);
  useEffect(function () {
    var el = getTargetElement(target);
    if (el && size) {
      var _getComputedStyle = getComputedStyle(el),
        paddingTop = _getComputedStyle.paddingTop,
        paddingBottom = _getComputedStyle.paddingBottom,
        paddingLeft = _getComputedStyle.paddingLeft,
        paddingRight = _getComputedStyle.paddingRight;
      var aw = size.width - (parseFloat(paddingLeft) + parseFloat(paddingRight));
      var ah = size.height - (parseFloat(paddingTop) + parseFloat(paddingBottom));
      var rows = 1,
        cols = 1;
      if (typeof itemMinHeight === 'number') {
        rows = Math.floor((ah + gutterY) / (itemMinHeight + gutterY));
      }
      if (typeof itemMinWidth === 'number') {
        cols = Math.floor((aw + gutterX) / (itemMinWidth + gutterX));
      }
      setGrid({
        rows: rows,
        cols: cols
      });
    }
  }, [gutterX, gutterY, itemMinHeight, itemMinWidth, size, target]);
  return grid;
}