import { useEffect, useRef } from 'react';
var _wr = function _wr(type) {
  var origin = window.history[type];
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    // @ts-ignore
    // eslint-disable-next-line @typescript-eslint/no-invalid-this
    var newEvent = origin.apply(this, args);
    var e = new Event(type);
    e.args = args;
    window.dispatchEvent(e);
    return newEvent;
  };
};
export function useVisitor(callbacks) {
  var deps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var timer = useRef();
  var callbacksRef = useRef(callbacks);
  var onStateChange = function onStateChange(type, e) {
    if (timer.current) {
      clearTimeout(timer.current);
    }
    timer.current = setTimeout(function () {
      var _e$args, _callbacksRef$current, _callbacksRef$current2;
      var data = e.state;
      if ((_e$args = e.args) === null || _e$args === void 0 ? void 0 : _e$args[0]) {
        data = e.args[0];
      }
      (_callbacksRef$current = (_callbacksRef$current2 = callbacksRef.current)[type]) === null || _callbacksRef$current === void 0 ? void 0 : _callbacksRef$current.call(_callbacksRef$current2, data);
    }, 5);
  };
  var onPopState = function onPopState(e) {
    onStateChange('onPopState', e);
  };
  var onPushState = function onPushState(e) {
    onStateChange('onPushState', e);
  };
  var onReplaceState = function onReplaceState(e) {
    onStateChange('onReplaceState', e);
  };
  useEffect(function () {
    callbacksRef.current = callbacks;
  }, [deps, callbacks]);
  var unregister = function unregister() {
    window.removeEventListener('popstate', onPopState);
    window.removeEventListener('pushState', onPushState);
    window.removeEventListener('replaceState', onReplaceState);
  };
  var register = function register() {
    window.addEventListener('popstate', onPopState);
    window.addEventListener('pushState', onPushState);
    window.addEventListener('replaceState', onReplaceState);
  };
  useEffect(function () {
    window.history.pushState = _wr('pushState');
    window.history.replaceState = _wr('replaceState');
    register();
    return function () {
      unregister();
      clearTimeout(timer.current);
    };
  }, []);
}